{% import 'arty_basic_node/cmake_header_macro.jinja' as header_macros %}
{{ header_macros.generate_do_not_edit(generation_date, the_arquetype, archetype.version) }}

cmake_minimum_required(VERSION 3.8)

project({{ project.name }})

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# Common dependencies used in the template
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(pluginlib REQUIRED)
find_package({{ plugin.package }} REQUIRED)

# User's dependencies from manifest
{% for dependency in dependencies %}
find_package({{ dependency }} REQUIRED)
{% endfor %}

include_directories(
  include
  include/${PROJECT_NAME}
)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

# Source files
set(SOURCES src/plugin.cpp)

# Add internal source files
file(GLOB INTERNAL_SOURCES "src/internal/*.cpp")

# Install include dir
install(
	DIRECTORY include/
	DESTINATION include
)

ament_export_include_directories(include)

##### PLUGIN Build and Install (plugin) ####

pluginlib_export_plugin_description_file({{ plugin.package }} plugins.xml)

add_library({{ project.name }} src/plugin.cpp ${INTERNAL_SOURCES})

# Require C99 and C++17
target_compile_features({{ project.name }} PUBLIC c_std_99 cxx_std_17)
target_include_directories({{ project.name }} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

target_include_directories(${PROJECT_NAME} PRIVATE
  {{'${'}}{{ plugin.package }}_INCLUDE_DIRS{{'}'}}
)

ament_target_dependencies(
	{{ project.name }}
	rclcpp
	pluginlib
	{% for dependency in dependencies %}
	{{ dependency }}
	{% endfor %}
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(
	{{ project.name }}
	PRIVATE "{{ project.name }}_BUILDING_LIBRARY"
)

install(
  TARGETS {{ project.name }}
  EXPORT export_{{ project.name }}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_export_libraries({{ project.name }})
ament_export_targets(export_{{ project.name }})

ament_package()